## dracut 110

=== Makefile ===

DRACUT_MAIN_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --abbrev=0 --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_MAIN_VERSION),)
DRACUT_MAIN_VERSION := $(shell sed -n 's/^DRACUT_VERSION="\(.*\)"$$/\1/p' dracut.sh)
endif
DRACUT_FULL_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_FULL_VERSION),)
DRACUT_FULL_VERSION := $(shell sed -n 's/^DRACUT_VERSION="\(.*\)"$$/\1/p' dracut.sh)
endif

HAVE_SHELLCHECK ?= $(shell command -v shellcheck >/dev/null 2>&1 && echo yes)
HAVE_SHFMT ?= $(shell command -v shfmt >/dev/null  2>&1 && echo yes)

-include Makefile.inc

prefix ?= /usr
libdir ?= ${prefix}/lib
datadir ?= ${prefix}/share
pkglibdir ?= ${libdir}/dracut
sysconfdir ?= ${prefix}/etc
bindir ?= ${prefix}/bin
mandir ?= ${prefix}/share/man
CFLAGS ?= -O2 -g -Wall -std=gnu99 -D_FILE_OFFSET_BITS=64 -Wformat -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2
bashcompletiondir ?= ${datadir}/bash-completion/completions
pkgconfigdatadir ?= $(datadir)/pkgconfig
ARCH ?= $(shell uname -m)

configs = \
	fips/10-fips.conf \
	generic/11-generic.conf \
	hostonly/10-hostonly.conf \
	ima/10-ima.conf \
	no-network/10-no-network.conf \
	rescue/10-rescue.conf \
	$(NULL)

test_configs = \
	test-makeroot/test-makeroot.conf \
	test-root/test-root.conf \
	test/test.conf \
	$(NULL)

man1pages = man/lsinitrd.1

man5pages = man/dracut.conf.5

man7pages = man/dracut.cmdline.7 \
            man/dracut.bootup.7 \
            man/dracut.modules.7

man8pages = man/dracut.8 \
            man/dracut-catimages.8 \
            modules.d/77dracut-systemd/dracut-cmdline.service.8 \
            modules.d/77dracut-systemd/dracut-mount.service.8 \
            modules.d/77dracut-systemd/dracut-shutdown.service.8 \
            modules.d/77dracut-systemd/dracut-pre-mount.service.8 \
            modules.d/77dracut-systemd/dracut-pre-pivot.service.8 \
            modules.d/77dracut-systemd/dracut-pre-trigger.service.8 \
            modules.d/77dracut-systemd/dracut-pre-udev.service.8 \
            modules.d/77initqueue/dracut-initqueue.service.8

manpages = $(man1pages) $(man5pages) $(man7pages) $(man8pages)

.PHONY: install clean distclean archive test all check AUTHORS CONTRIBUTORS doc

all: dracut.pc dracut-install src/skipcpio/skipcpio dracut-util

%.o : %.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(KMOD_CFLAGS) $(SYSTEMD_CFLAGS) $(if $(SYSTEMD_LIBS),-DHAVE_SYSTEMD) $< -o $@

DRACUT_INSTALL_OBJECTS = \
        src/install/dracut-install.o \
        src/install/hashmap.o\
        src/install/log.o \
        src/install/strv.o \
        src/install/util.o

# deps generated with gcc -MM
src/install/dracut-install.o: src/install/dracut-install.c src/install/log.h src/install/macro.h \
	src/install/hashmap.h src/install/util.h
src/install/hashmap.o: src/install/hashmap.c src/install/util.h src/install/macro.h src/install/log.h \
	src/install/hashmap.h
src/install/log.o: src/install/log.c src/install/log.h src/install/macro.h src/install/util.h
src/install/util.o: src/install/util.c src/install/util.h src/install/macro.h src/install/log.h
src/install/strv.o: src/install/strv.c src/install/strv.h src/install/util.h src/install/macro.h src/install/log.h

src/install/dracut-install: $(DRACUT_INSTALL_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(DRACUT_INSTALL_OBJECTS) $(LDLIBS) $(FTS_LIBS) $(KMOD_LIBS) $(SYSTEMD_LIBS)

dracut-install: src/install/dracut-install
	ln -fs $< $@

SKIPCPIO_OBJECTS = src/skipcpio/skipcpio.o
skipcpio/skipcpio.o: src/skipcpio/skipcpio.c
skipcpio/skipcpio: $(SKIPCPIO_OBJECTS)

UTIL_OBJECTS = src/util/util.o
util/util.o: src/util/util.c
util/util: $(UTIL_OBJECTS)

dracut-util: src/util/util
	cp -a $< $@

.PHONY: indent-c
indent-c:
	astyle -n --quiet --options=.astylerc $(wildcard *.[ch] */*.[ch] src/*/*.[ch])

.PHONY: indent
indent: indent-c
ifeq ($(HAVE_SHFMT),yes)
	shfmt --apply-ignore -w .
endif

src/dracut-cpio/target/release/dracut-cpio: src/dracut-cpio/src/main.rs
	cargo --offline build --release --manifest-path src/dracut-cpio/Cargo.toml

dracut-cpio: src/dracut-cpio/target/release/dracut-cpio
	ln -fs $< $@

ifeq ($(enable_dracut_cpio),yes)
all: dracut-cpio
endif

doc: $(manpages)

ifneq ($(enable_documentation),no)
all: doc
endif

ifeq ($(disable_asciidoctor),yes)
$(warning *** Building with asciidoc deprecated)
%: %.xml
	@rm -f -- "$@"
	xsltproc -o "$@" -nonet http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl $<

%.xml: %.adoc
	@rm -f -- "$@"
	asciidoc -f man/asciidoc.conf -a "version=$(DRACUT_FULL_VERSION)" -d manpage -b docbook -o "$@" $<
else
define ASCIIDOC_MANPAGE
	asciidoctor -a "version=$(DRACUT_FULL_VERSION)" -b manpage $<
endef

%.1: %.1.adoc
	$(ASCIIDOC_MANPAGE)
%.5: %.5.adoc
	$(ASCIIDOC_MANPAGE)
%.7: %.7.adoc
	$(ASCIIDOC_MANPAGE)
%.8: %.8.adoc
	$(ASCIIDOC_MANPAGE)
endif

# If ANOTRA_BIN not set, default to look for "npx" to run "npx antora".  If we
# end up with undefined ANTORA_BIN (i.e. not set and npx not found), we'll give
# a sane error when building docs below.
ifeq ($(ANTORA_BIN),)
NPX := $(shell command -v npx 2> /dev/null)
ifneq ($(NPX),)
ANTORA_BIN := "$(NPX) antora"
endif
endif
.PHONY: doc_site
doc_site: $(manpages) doc_site/modules/ROOT/nav.adoc doc_site/modules/ROOT/pages/index.adoc
ifndef ANTORA_BIN
	$(error Antora not found, install nodejs or set ANTORA_BIN to make doc site)
endif
	mkdir -p doc_site/modules/ROOT/pages/man
	cd doc_site/modules/ROOT/pages/man/; for i in $(manpages) man/dracut.usage; do ln -sf ../../../../../$${i}.adoc $(basename $i); done
	$(shell echo $(ANTORA_BIN)) --attribute "mainversion=$(DRACUT_MAIN_VERSION)" \
	  --attribute "version=${DRACUT_FULL_VERSION}" \
	  antora-playbook.yml

dracut.8: man/dracut.8.adoc \
	man/dracut.usage.adoc

dracut.pc: Makefile.inc Makefile
	@echo "Name: dracut" > dracut.pc
	@echo "Description: dracut" >> dracut.pc
	@echo "Version: $(DRACUT_FULL_VERSION)" >> dracut.pc
	@echo "dracutdir=$(pkglibdir)" >> dracut.pc
	@echo "dracutmodulesdir=$(pkglibdir)/modules.d" >> dracut.pc
	@echo "dracutconfdir=$(pkglibdir)/dracut.conf.d" >> dracut.pc

install: all
	mkdir -p $(DESTDIR)$(pkglibdir)
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(sysconfdir)
	mkdir -p $(DESTDIR)$(pkglibdir)/modules.d
	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man5 $(DESTDIR)$(mandir)/man7 $(DESTDIR)$(mandir)/man8
	install -m 0755 dracut.sh $(DESTDIR)$(bindir)/dracut
	sed -i 's;^\(DRACUT_VERSION\)=".*"$$;\1="$(DRACUT_FULL_VERSION)";' $(DESTDIR)$(bindir)/dracut
	install -m 0755 dracut-catimages.sh $(DESTDIR)$(bindir)/dracut-catimages
	install -m 0755 lsinitrd.sh $(DESTDIR)$(bindir)/lsinitrd
	install -m 0644 dracut.conf $(DESTDIR)$(sysconfdir)/dracut.conf
	mkdir -p $(DESTDIR)$(sysconfdir)/dracut.conf.d
	mkdir -p $(DESTDIR)$(pkglibdir)/dracut.conf.d
	install -m 0755 dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions.sh
	ln -fs dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions
	install -m 0755 dracut-logger.sh $(DESTDIR)$(pkglibdir)/dracut-logger.sh
	install -m 0755 dracut-initramfs-restore.sh $(DESTDIR)$(pkglibdir)/dracut-initramfs-restore
	for module in modules.d/*; do \
		if test -L "$$module"; then cp -d "$$module" "$(DESTDIR)$(pkglibdir)/modules.d"; continue; fi; \
		install -m 0755 -d "$$module" "$(DESTDIR)$(pkglibdir)/$$module"; \
		for file in "$$module"/*; do \
			mode=0755; test -x "$$file" || mode=0644; \
			install -m "$$mode" "$$file" "$(DESTDIR)$(pkglibdir)/$$file"; \
		done; \
	done
	for conf in $(configs); do \
		install -D -m 0644 "dracut.conf.d/$$conf" "$(DESTDIR)$(pkglibdir)/dracut.conf.d/$$conf"; \
	done
	for i in $(configprofile) ; do \
		install -m 0644 dracut.conf.d/$$i/* $(DESTDIR)$(pkglibdir)/dracut.conf.d/ ;\
	done
ifeq ($(enable_test),yes)
	cp -a test $(DESTDIR)$(pkglibdir)
	for conf in $(test_configs); do \
		install -D -m 0644 "dracut.conf.d/$$conf" "$(DESTDIR)$(pkglibdir)/dracut.conf.d/$$conf"; \
	done
else
	rm -rf $(DESTDIR)$(pkglibdir)/modules.d/70test*
	rm -rf $(DESTDIR)$(pkglibdir)/dracut.conf.d/test*
endif
ifneq ($(enable_documentation),no)
	for i in $(man1pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man1/$${i##*/}; done
	for i in $(man5pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man5/$${i##*/}; done
	for i in $(man7pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man7/$${i##*/}; done
	for i in $(man8pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man8/$${i##*/}; done
	ln -fs dracut.cmdline.7 $(DESTDIR)$(mandir)/man7/dracut.kernel.7
endif
	if [ -n "$(systemdsystemunitdir)" ]; then \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir); \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/77dracut-systemd/dracut-shutdown-onfailure.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown-onfailure.service; \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/77dracut-systemd/dracut-shutdown.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants; \
		ln -sf ../dracut-shutdown.service \
		$(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants; \
		for i in \
		    dracut-cmdline.service \
		    dracut-mount.service \
		    dracut-pre-mount.service \
		    dracut-pre-pivot.service \
		    dracut-pre-trigger.service \
		    dracut-pre-udev.service \
		    ; do \
			ln -srf $(DESTDIR)$(pkglibdir)/modules.d/77dracut-systemd/$$i $(DESTDIR)$(systemdsystemunitdir); \
			ln -sf ../$$i \
			$(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants/$$i; \
		done; \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/77initqueue/dracut-initqueue.service $(DESTDIR)$(systemdsystemunitdir); \
		ln -sf ../dracut-initqueue.service \
		$(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants/dracut-initqueue.service; \
	fi
	if [ -f src/install/dracut-install ]; then \
		install -m 0755 src/install/dracut-install $(DESTDIR)$(pkglibdir)/dracut-install; \
	fi
	if [ -f src/skipcpio/skipcpio ]; then \
		install -m 0755 src/skipcpio/skipcpio $(DESTDIR)$(pkglibdir)/skipcpio; \
	fi
	if [ -f dracut-util ]; then \
		install -m 0755 dracut-util $(DESTDIR)$(pkglibdir)/dracut-util; \
	fi
ifeq ($(enable_dracut_cpio),yes)
	install -m 0755 dracut-cpio $(DESTDIR)$(pkglibdir)/dracut-cpio
endif
	mkdir -p $(DESTDIR)${prefix}/lib/kernel/install.d
	install -m 0755 install.d/50-dracut.install $(DESTDIR)${prefix}/lib/kernel/install.d/50-dracut.install
	install -m 0755 install.d/51-dracut-rescue.install $(DESTDIR)${prefix}/lib/kernel/install.d/51-dracut-rescue.install
	mkdir -p $(DESTDIR)${bashcompletiondir}
	install -m 0644 shell-completion/bash/dracut $(DESTDIR)${bashcompletiondir}/dracut
	install -m 0644 shell-completion/bash/lsinitrd $(DESTDIR)${bashcompletiondir}/lsinitrd
	mkdir -p $(DESTDIR)${pkgconfigdatadir}
	install -m 0644 dracut.pc $(DESTDIR)${pkgconfigdatadir}/dracut.pc
ifneq ($(enable_network_legacy),yes)
	rm -r $(DESTDIR)$(pkglibdir)/modules.d/[0-9][0-9]network-legacy
endif
	if ! [ -n "$(systemdsystemunitdir)" ]; then \
		rm -rf $(DESTDIR)$(pkglibdir)/test/TEST-[0-9][0-9]-*SYSTEMD* ;\
		rm -rf $(DESTDIR)$(pkglibdir)/modules.d/*systemd* $(DESTDIR)$(mandir)/man8/*.service.* ; \
		for i in bluetooth connman dbus* fido2 lvmmerge lvmthinpool-monitor memstrack pcsc pkcs11 rngd squash* tpm2-tss; do \
			rm -r $(DESTDIR)$(pkglibdir)/modules.d/[0-9][0-9]$${i}; \
		done \
	fi
ifneq ($(ARCH),s390x)
	for f in cio_ignore cms dasd dasd_mod dcssblk zfcp zipl znet; do \
		rm -r $(DESTDIR)$(pkglibdir)/modules.d/[0-9][0-9]$${f}; \
	done
else
	rm -r $(DESTDIR)$(pkglibdir)/modules.d/[0-9][0-9]warpclock
endif

clean:
	$(RM) *~
	$(RM) */*~
	$(RM) */*/*~
	$(RM) $(manpages:%=%.xml) dracut.xml
	$(RM) dracut-*.tar.bz2 dracut-*.tar.xz
	$(RM) dracut-install src/install/dracut-install $(DRACUT_INSTALL_OBJECTS)
	$(RM) src/skipcpio/skipcpio $(SKIPCPIO_OBJECTS)
	$(RM) dracut-util src/util/util $(UTIL_OBJECTS)
	$(RM) $(manpages)
	$(RM) dracut.pc

=== test/TEST-21-OVERLAYFS/Makefile ===
include ../Makefile.testdir

=== debian/changelog ===
dracut (110-3ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - autopkgtest: skip too slow 41-full-systemd on arm64 and armhf
      (see LP 2133401)
    - dracut-core: Declare breaking rust-coreutils before version 0.5.0
    - autopkgtest: explicitly depend on libarchive13t64

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 27 Feb 2026 20:58:13 +0100

dracut (110-3) unstable; urgency=medium

  [ Hector Cao ]
  * test: force cpu to neoverse-n1 for arm64 when QEMU_CPU not set
    (Closes: #1128969, LP: #2142121)

 -- Benjamin Drung <bdrung@debian.org>  Thu, 26 Feb 2026 17:08:57 +0100

dracut (110-2) unstable; urgency=medium

  * Run MD RAID test cases in test 70 and 71 again (fixed in mdadm 4.5-5)
  * fix(multipath): include Debian-specific priority of udev rules until
    Debian and upstream agrees on one common numbering (see LP 2137190)
  * Build-depend on libsystemd-dev to build dracut-install with JSON support
    (Closes: #1128349)
  * Apply upstream patches to fix failing autopkgtest 14-hooks on Ubuntu:
    - fix(kernel-modules-export): use return instead of exit in pre-pivot hook
    - fix(memdisk): use return instead of exit in cmdline hook
    - fix(ppcmac): use return instead of exit in pre-udev hook
    - fix(syslog): use return instead of exit in initqueue/online hook
  * dracut-test: add run-qemu and test-functions
  * autopkgtest: Doule timeout to 20 min for slow architectures armhf, riscv64

 -- Benjamin Drung <bdrung@debian.org>  Mon, 23 Feb 2026 14:25:02 +0100

dracut (110-1ubuntu2) resolute; urgency=medium

  * Drop test-skip-failing-MD-RAID-tests-cases-in-test-70-and-71.patch
  * Apply patches to fix failing autopkgtest 14-hooks:
    - fix(kernel-modules-export): use return instead of exit in pre-pivot hook
    - fix(memdisk): use return instead of exit in cmdline hook
    - fix(ppcmac): use return instead of exit in pre-udev hook
    - fix(syslog): use return instead of exit in initqueue/online hook

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 11 Feb 2026 17:43:47 +0100

dracut (110-1ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - autopkgtest: skip too slow 41-full-systemd on arm64 and armhf
      (see LP 2133401)
    - dracut-core: Declare breaking rust-coreutils before version 0.5.0
  * autopkgtest: run 43-kernel-install on arm64 again (LP: #2133402)
  * dracut-test: add run-qemu and test-functions
  * autopkgtest: depend on libarchive13t64 (fixed in systemd 259.1-1)

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 09 Feb 2026 13:20:58 +0100

dracut (110-1) unstable; urgency=medium

  * New upstream release.
  * Drop all patches applied upstream
  * dracut-core:
    - remove dropped uki-virt and no-xattr Dracut config
    - remove merged dracut-init.sh and dracut-version.sh
    - rename systemd-pcrphase to systemd-pcrextend
    - order systemd-cryptsetup after crypt Dracut module
    - add new memdisk Dracut module
  * dracut-network:
    - add new systemd-import Dracut module and suggest systemd-container for it
    - Drop network-legacy dracut module (and isc-dhcp-client support)
  * autopkgtest: add new upstream tests 14-hooks, 21-overlayfs, 31-livenet,
    and 45-systemd-import
  * autopkgtest: do not require make for running upstream tests
  * test: skip failing MD RAID tests cases in test 70 and 71 (mdadm 4.5 bug)

 -- Benjamin Drung <bdrung@debian.org>  Mon, 09 Feb 2026 02:05:10 +0100

dracut (109-11ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - autopkgtest: skip failing 43-kernel-install on arm64 (see LP 2133402)
    - autopkgtest: skip too slow 41-full-systemd on arm64 and armhf
      (see LP 2133401)
    - dracut-core: Declare breaking rust-coreutils before version 0.5.0

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 04 Feb 2026 01:04:58 +0100

dracut (109-11) unstable; urgency=medium

  * autopkgtest: explicitly depend on dmsetup for test 60-nfs

 -- Benjamin Drung <bdrung@debian.org>  Fri, 30 Jan 2026 22:36:56 +0100

dracut (109-10) unstable; urgency=medium

  * Let firmware package updates trigger the dracut autopkgtest
  * dracut-core: document which Dracut module needs suggested packages
  * Merge dracut-squash into dracut-core
  * Move the livenet Dracut module to dracut-network and merge the remaining
    dracut-live into dracut-core
  * fix(tpm2-tss): add tss user/group in addition to sysusers config
    (LP: #2127725)
  * autopkgtest: depend on erofs-utils and xorriso in test 30

 -- Benjamin Drung <bdrung@debian.org>  Fri, 30 Jan 2026 15:08:55 +0100

dracut (109-9ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Let linux-firmware updates trigger the dracut autopkgtest
    - autopkgtest: skip failing 43-kernel-install on arm64 (see LP 2133402)
    - autopkgtest: skip too slow 41-full-systemd on arm64 and armhf
      (see LP 2133401)
  * Dropped changes:
    - dracut-core: demote binutils to suggests. its only needed when using UEFI
      executables
    - fix(udev-rules): exclude udev rules from snapd. Let snapd ship a Dracut
      config file instead (see LP 2139065)
    - feat(dmsquash-live-autooverlay): support readlink from uutils
      (fixed by rust-coreutils 0.5.0)
    - test: use GNU dd instead of uutil's dd (to work around bug LP 2129037)
      (fixed by rust-coreutils 0.4.0)
  * dracut-core: Declare breaking rust-coreutils before version 0.5.0

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 26 Jan 2026 11:47:44 +0100

dracut (109-9) unstable; urgency=medium

  * feat: warn in case 3cpio is present but not suitable (Closes: #1125948)
  * dracut-core: Prefer 3cpio over cpio again

 -- Benjamin Drung <bdrung@debian.org>  Sat, 24 Jan 2026 19:43:56 +0100

dracut (109-8) unstable; urgency=medium

  [ Bastian Blank ]
  * Revert to use cpio. (closes: #1125948)

  [ Benjamin Drung ]
  * Drop unneeded udevsettle patch (see upstream issue 2067)



=== debian/control ===
Source: dracut
Section: utils
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Thomas Lange <lange@debian.org>, Benjamin Drung <bdrung@debian.org>
Build-Depends: debhelper-compat (= 13),
               3cpio [!alpha !hppa !m68k !sh4] <!nocheck>,
               asciidoctor,
               bash-completion,
               cpio [alpha hppa m68k sh4] <!nocheck>,
               libkmod-dev,
               libsystemd-dev,
               pkgconf,
               shellcheck [!i386 !m68k !powerpc !sh4 !x32] <!nocheck>,
               shfmt [!alpha !hppa !i386 !m68k !powerpc !sh4 !sparc64 !x32] <!nocheck>,
               systemd-dev
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/kernel-team/dracut
Vcs-Git: https://salsa.debian.org/kernel-team/dracut.git
Homepage: https://github.com/dracut-ng/dracut-ng/wiki

Package: dracut-core
Architecture: any
Multi-Arch: foreign
Depends: 3cpio | cpio,
         dracut-install,
         e2fsprogs,
         kmod,
         systemd-sysv | initscripts | sysvinit-core,
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: binutils, console-setup, systemd, zstd
Suggests: cryptsetup,
          dmsetup,
          isomd5sum,
          kpartx,
          lvm2,
          mdadm,
          parted,
          squashfs-tools,
          systemd-cryptsetup
Breaks: dracut-live (<< 109-10~),
        dracut-network (<< 057+157-2),
        dracut-squash,
        rust-coreutils (<< 0.5.0)
Replaces: dracut-live (<< 109-10~),
          dracut-network (<< 057+157-2),
          dracut-squash
Provides: dracut-live
Description: dracut is an event driven initramfs infrastructure (core tools)
 Unlike existing initramfs's, this is an attempt at having as little as
 possible hard-coded into the initramfs as possible.  The initramfs has
 (basically) one purpose in life -- getting the rootfs mounted so that
 it can transition to the real rootfs.  This is all driven off of
 device availability.  Therefore, instead of scripts hard-coded to do
 various things, it depends on udev to create device nodes and
 to detect the rootfs.
 Having the root on MD, LVM2, LUKS is supported as well as NFS, iSCSI,
 NBD and FCOE with dracut-network.
 .
 These Dracut modules need suggested packages:
  * crypt: cryptsetup or systemd-cryptsetup
  * dm: dmsetup
  * dmraid: kpartx
  * dmsquash-live: isomd5sum (optionally)
  * dmsquash-live-autooverlay: parted
  * dracut-systemd: systemd-cryptsetup (when crypt and systemd are used)
  * lvm: lvm2
  * lvmmerge: lvm2
  * lvmthinpool-monitor: lvm2
  * mdraid: mdadm
  * multipath: kpartx
  * squash-squashfs: squashfs-tools
  * systemd-cryptsetup: systemd-cryptsetup

Package: dracut
Architecture: all
Multi-Arch: foreign
Depends: dracut-core (<< ${binary:Version}+b+~),
         dracut-core (>= ${binary:Version}),
         linux-base,
         ${misc:Depends}
Suggests: dracut-network
Provides: linux-initramfs-tool
Conflicts: initramfs-tools, live-tools
Description: Initramfs generator using udev
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: dracut-install
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: dracut-core (<< 060+5-7~)
Replaces: dracut-core (<< 060+5-7~)
Description: dracut is an event driven initramfs infrastructure (dracut-install)
 This package just contains the dracut-install command to be used by
 initramfs generating tools.

Package: dracut-network
Architecture: all
Multi-Arch: foreign
Depends: dracut-core,
         iproute2,
         network-manager | systemd | connman,
         ${misc:Depends}
Recommends: curl, nbd-client, nfs-common, open-iscsi
Suggests: iscsiuio, systemd-container
Breaks: dracut-core (<< 105), dracut-live (<< 109-10~)
Replaces: dracut-core (<< 105), dracut-live (<< 109-10~)
Description: dracut is an event driven initramfs infrastructure (network modules)
 Package to build a dracut initramfs with network support. This
 includes dracut modules for NFS, CIFS, iSCSI, HTTP, NBD, FCP and FCOE.
 .
 These Dracut modules need suggested packages:
  * systemd-import: systemd-container
  * iscsi: iscsiuio (optionally)

Package: dracut-test
Architecture: any
Multi-Arch: foreign
Depends: dracut-core,
         ipxe-qemu,
         linux-image-generic [!i386],
         mount,
         ovmf [amd64],
         qemu-efi-aarch64 [arm64],
         qemu-system-native [!i386],
         seabios [ppc64el],
         systemd (>= 259~rc1),
         zstd,
         ${misc:Depends}
Breaks: dracut-core (<< 105)
Replaces: dracut-core (<< 105)
Description: dracut is an event driven initramfs infrastructure (test modules)
 This package provides the Dracut modules and configuration files for the
 Dracut test suite. This package is intended for testing Dracut itself
 and is of no use for ordinary users. If you're not sure about this package,
 you don't need it.
 .
 This package has following additional dependencies for reducing the amount
 of dependencies needed in autopkgtest:
 .
  * Linux kernel
  * QEMU
  * Recommends from dracut-core

=== debian/tests/control ===
Tests: lsinitrd
Architecture: !armel !i386
Depends: dracut, linux-image-generic, zstd
Restrictions: needs-root, superficial

Tests: 10-basic,
       13-sysroot,
       14-hooks,
       21-overlayfs,
       40-systemd,
       42-systemd-initrd,
       43-kernel-install,
       80-getarg,
       81-skipcpio
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: dracut-test

Tests: 11-usr-mount
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: btrfs-progs, dracut-test

# Fails on arm64: https://github.com/dracut-ng/dracut-ng/issues/1862
Tests: 12-uefi
Architecture: amd64
Restrictions: allow-stderr, needs-root
Depends: dracut-test,
         kbd,
         lvm2,
         squashfs-tools,
         systemd-boot-efi,
         systemd-cryptsetup,
         systemd-ukify

Tests: 20-storage, 26-enc-raid-lvm
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: cryptsetup, dracut-test, lvm2, mdadm, systemd-cryptsetup

Tests: 30-dmsquash
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: dmsetup,
         dracut-network,
         dracut-test,
         erofs-utils,
         fdisk,
         parted,
         squashfs-tools,
         util-linux-extra,
         xorriso

Tests: 31-livenet
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: curl, dmsetup, dracut-network, dracut-test, python3, squashfs-tools

# Too slow on Ubuntu arm64 and armhf: https://launchpad.net/bugs/2133401
Tests: 41-full-systemd
Architecture: !arm64 !armel !armhf !i386
Restrictions: allow-stderr, needs-root
Depends: btrfs-progs,
         cryptsetup,
         dracut-network,
         dracut-test,
         systemd-container,
         systemd-coredump,
         systemd-cryptsetup,
         systemd-repart,
         systemd-resolved,
         systemd-timesyncd

Tests: 44-drivers
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: dracut-test, xfsprogs

# libarchive is required by systemd-import for systemd >= v259: https://launchpad.net/bugs/2139822
Tests: 45-systemd-import
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: dracut-network,
         dracut-test,
         erofs-utils,
         gpg,
         gpg-agent,
         libarchive13t64,
         python3,
         squashfs-tools,
         systemd-container

Tests: 50-network
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: dracut-network, dracut-test

Tests: 60-nfs
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: curl,
         dmsetup,
         dracut-network,
         dracut-test,
         isc-dhcp-server,
         nfs-kernel-server,
         procps

Tests: 70-iscsi, 71-iscsi-multi
Architecture: !armel !i386
Restrictions: allow-stderr, needs-root
Depends: cryptsetup,
         dracut-network,
         dracut-test,
         isc-dhcp-server,
         lvm2,
         mdadm,
         open-iscsi,
         procps,
         systemd-cryptsetup,
